"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _immutable = require("immutable");

var _draftJs = require("draft-js");

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var alias = {
  javascript: "js",
  jsx: "js"
};

function CodeSwitchContainer(props) {
  function handleClickOutside() {
    props.onClickOutside();
  }

  return _react["default"].createElement(_reactOutsideClickHandler["default"], {
    onOutsideClick: function onOutsideClick() {
      return handleClickOutside();
    }
  }, _react["default"].createElement("div", {
    contentEditable: false,
    onClick: this.props.onClick
  }, props.children));
}

function CodeBlock(props) {
  var _this = this;

  state = {
    isOpen: false
  };

  onChange = function onChange(ev) {
    ev.preventDefault();
    ev.stopPropagation();

    var blockKey = _this.props.block.getKey();

    var _this$props$blockProp = _this.props.blockProps,
        getEditorState = _this$props$blockProp.getEditorState,
        setReadOnly = _this$props$blockProp.setReadOnly,
        setEditorState = _this$props$blockProp.setEditorState;
    var editorState = getEditorState();
    var selection = editorState.getSelection();
    var language = ev.currentTarget.value;
    var blockSelection = selection.merge({
      anchorKey: blockKey,
      focusKey: blockKey
    });

    _this.setState({
      isOpen: false
    });

    var content = editorState.getCurrentContent();
    content = _draftJs.Modifier.mergeBlockData(content, blockSelection, (0, _immutable.Map)({
      language: language
    }));
    setReadOnly(false);

    var newEditorState = _draftJs.EditorState.push(editorState, content, "change-block-data");

    setEditorState(_draftJs.EditorState.forceSelection(newEditorState, selection));
  };

  function cancelClicks(event) {
    return event.preventDefault();
  }

  function onSelectClick(event) {
    this.setState({
      isOpen: true
    });
    var setReadOnly = this.props.blockProps.setReadOnly;
    event.stopPropagation();
    setReadOnly(true);
    this.setState({
      isOpen: true
    });
  }

  function onClickOutside() {
    if (this.state.isOpen === false) return;
    this.setState({
      isOpen: false
    });
    var _this$props$blockProp2 = this.props.blockProps,
        getEditorState = _this$props$blockProp2.getEditorState,
        setReadOnly = _this$props$blockProp2.setReadOnly,
        setEditorState = _this$props$blockProp2.setEditorState;
    setReadOnly(false);
    this.setState({
      isOpen: false
    });
    var editorState = getEditorState();
    var selection = editorState.getSelection();
    setEditorState(_draftJs.EditorState.forceSelection(editorState, selection));
  }

  var _this$props$blockProp3 = this.props.blockProps,
      languages = _this$props$blockProp3.languages,
      renderLanguageSelect = _this$props$blockProp3.renderLanguageSelect,
      getReadOnly = _this$props$blockProp3.getReadOnly,
      _language = _this$props$blockProp3.language;
  var language = alias[_language] || _language;
  var selectedLabel = languages[language];
  var selectedValue = language;
  var options = Object.keys(languages).reduce(function (acc, val) {
    return [].concat(_toConsumableArray(acc), [{
      label: languages[val],
      value: val
    }]);
  }, []);
  return _react["default"].createElement("div", null, _react["default"].createElement(_draftJs.EditorBlock, this.props), " ", _react["default"].createElement(CodeSwitchContainer, {
    onClickOutside: this.onClickOutside,
    onClick: this.onSelectClick
  }, " ", !getReadOnly() && renderLanguageSelect({
    selectedLabel: selectedLabel,
    selectedValue: selectedValue,
    onChange: this.onChange,
    options: options
  }), " "), " ");
}

var _default = CodeBlock;
exports["default"] = _default;